
<?php
try {
    require_once "vk_api.class.php";
    
    $channels  = array(
        "http://habrahabr.ru/rss/best/",
        "http://lenta.ru/rss/news/science/soft",
        "http://lenta.ru/rss/news/science/gadget",
    );

    $vk_api    = new VkApi("{ACCESS_TOKEN}");
    /*
    -- Таблица для уже опубликованных новостей
    
    --
    -- Структура таблицы `published_links`
    --

    CREATE TABLE IF NOT EXISTS `published_links` (
      `link` varchar(128) NOT NULL,
      UNIQUE KEY `link` (`link`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

    */
    $dbh       = new PDO("mysql:host=192.168.1.2;dbname={vk};charset=utf8", "{root}", "{}");

    foreach($channels as $channel) {

        $feed = simplexml_load_file($channel);

        foreach( $feed->channel->item as $item) {
            // Новости старше 24 часов не публикуем
            if( ( time() - strtotime($item->pubDate) ) > 60*60*24 ) {
                continue;
            }

            $sth = $dbh->prepare("SELECT EXISTS ( SELECT * FROM `published_links` WHERE `link` = ? ) ");
            $sth->execute(array($item->link));

            if(!$sth->fetch(PDO::FETCH_NUM)[0]) {

                $vk_api->api("wall.post", array( //https://vk.com/dev/wall.post
                    "owner_id"    => "-{16463854}", // Обязательно с минусом
                    "from_group"  => 1,
                    "attachments" => $item->link
                ));

                $sth = $dbh->prepare("INSERT INTO `published_links` (`link`) VALUES (?)");
                $sth->execute(array($item->link));

                // Останавливаем оба цикла, чтобы за 1 раз публиковалась только одна новость.
                break 2;
            }
        }

    }

    $dbh = null;

} catch (Exception $e) {
    print($e->getMessage());
}
?>